#ifndef IPCSOCKET_H
#define IPCSOCKET_H

#include <QObject>

class QLocalServer;

class IPCSocket : public QObject
{
	Q_OBJECT

public:
	enum State { NotConnected, Client, Server };
public:
	IPCSocket(QObject *parent = 0);
	IPCSocket(const QString &name, QObject *parent = 0);
	virtual ~IPCSocket();

	void connectTo(const QString &name);
	State state();

public slots:
	void sendMessage(const QByteArray &msg);

protected slots:
	void processConnection();
	void dispatchMessage(const QByteArray &msg);
	void resetState();
	void relayConnectedSignal();

signals:
	void message(const QByteArray &msg);
	void sigSendMessage(const QByteArray &msg);
	void disconnecting();
	void connected();

private:
	QLocalServer *sock;
	State currentState;
};

#endif // IPCSOCKET_H
