#ifndef PATH_H
#define PATH_H

#include <QByteArray>
#include <QString>
#include <QDateTime>
#include "userid.h"

class Path
{
public:
    Path();

	QString pwd();
	bool cwd(const QString &path);
	bool mkd(const QString &name);
	bool rmd(const QString &name);
	bool dele(const QString &name);
	bool rename(const QString &from, const QString &to);
	bool cdup();
	void list(QList<QByteArray> &sList, bool utf8 = false);
	void list(QList<QByteArray> &sList, const QString &filename, bool utf8 = false);
	void nlst(QList<QByteArray> &sList, bool utf8 = false);
	bool exists(const QString &path);
	QString absolute(const QString &path);
	QString realPath(const QString &path);
	void chmod(const QString &path, QByteArray perms);
	qint64 size(const QString &name);
	QDateTime lastModified(const QString &name);
	bool isReadable(const QString &name);
	bool isWritable(const QString &name);

	void SetUID(const UserID &uid);

private:
	QString currentPath;
	UserID uid;

public:
	static const QString separator;
};

#endif // PATH_H
