#ifndef STATS_H
#define STATS_H

#include <QtGui/QDialog>
#include <QTime>

namespace Ui {
    class Stats;
}

class Stats : public QDialog {
    Q_OBJECT
public:
    Stats(QWidget *parent = 0);
    ~Stats();

protected:
    void changeEvent(QEvent *e);
	void showEvent(QShowEvent *e);

public slots:
	void updateStats();
private slots:
	void updateChart();

private:
    Ui::Stats *m_ui;
	qint64 prevSent;
	qint64 prevRecv;
	QList<double> timeline;
	QList<qint64> bytesOut;
	QList<qint64> bytesIn;
	QList<qint64> connections;
	QTime clock;

private:
	static Stats *pInstance;
public:
	static Stats *instance();
	static void deleteInstance();
};

#endif // STATS_H
