#ifndef USERSPATH_H
#define USERSPATH_H

#include <QString>
#include <QList>
#include <QByteArray>
#include <QDateTime>

class UserID;

class UsersPath
{
private:
	inline UsersPath()	{}

public:
	static bool mkd(const UserID &uid, const QString &name);
	static bool rmd(const UserID &uid, const QString &name);
	static bool dele(const UserID &uid, const QString &name);
	static bool rename(const UserID &uid, const QString &from, const QString &to);
	static void list(const UserID &uid, QList<QByteArray> &out, const QString &name, bool utf8 = false);
	static void nlst(const UserID &uid, QList<QByteArray> &out, const QString &name, bool utf8 = false);
	static bool exists(const UserID &uid, const QString &path);
	static void chmod(const UserID &uid, const QString &path, QByteArray perms);
	static bool isDir(const UserID &uid, const QString &path);
	static bool isFile(const UserID &uid, const QString &path);
	static bool isReadable(const UserID &uid, const QString &path);
	static bool isWritable(const UserID &uid, const QString &path);
	static qint64 size(const UserID &uid, const QString &path);
	static QDateTime lastModified(const UserID &uid, const QString &name);
	static QStringList listDirs(const UserID &uid, const QString &name);
	static QStringList listAll(const UserID &uid, const QString &name);

private:
	static QString makePath(const QStringList &keys);

private:
	static const QChar separator;
};

#endif // USERSPATH_H
